Ubuntu 16.04安裝Nginx

Young5566發表於2018-12-27

在ubuntu中安裝nginx有兩種方式,分別是apt安裝和原始碼安裝,如果想要安裝最新版就需要下載原始碼編譯安裝。

apt安裝

sudo apt-get install nginx
複製程式碼

/usr/sbin/nginx : 主程式位置
/etc/nginx:nginx檔案配置
/usr/share/nginx:存放靜態檔案
/var/log/nginx:存放日誌
有關nginx對映配置檔案預設放在/etc/nginx/sites-available/中的default檔案,但為了方便管理,一般會在/etc/nginx/conf.d/中建立一個新的配置檔案。
使用apt安裝可以不用配置使用如下命令:

sudo service nginx {start|stop|restart|reload|force-reload|status|configtest|rotate|upgrade}的命令啟動。
複製程式碼

原始碼安裝

安裝nginx依賴庫

安裝gcc g++的依賴庫
apt-get install build-essential
apt-get install libtool
複製程式碼
安裝 pcre依賴庫
sudo apt-get update
sudo apt-get install libpcre3 libpcre3-dev
複製程式碼
安裝 zlib依賴庫
apt-get install zlib1g-dev
複製程式碼
安裝 ssl依賴庫
apt-get install openssl
複製程式碼

安裝nginx

#下載最新版本:
wget http://nginx.org/download/nginx-1.11.3.tar.gz
#解壓:
tar -zxvf nginx-1.11.3.tar.gz
#進入解壓目錄:
cd nginx-1.11.3
#配置:
./configure --prefix=/usr/local/nginx 
#編輯nginx:
make
注意:這裡可能會報錯,提示“pcre.h No such file or directory”,具體詳見:http://stackoverflow.com/questions/22555561/error-building-fatal-error-pcre-h-no-such-file-or-directory
需要安裝 libpcre3-dev,命令為:sudo apt-get install libpcre3-dev
#安裝nginx:
sudo make install
#啟動nginx:
sudo /usr/local/nginx/sbin/nginx -c /usr/local/nginx/conf/nginx.conf
注意:-c 指定配置檔案的路徑,不加的話,nginx會自動載入預設路徑的配置檔案,可以通過 -h檢視幫助命令。
#檢視nginx程式:
ps -ef|grep nginx
複製程式碼

原始碼安裝時,啟用nginx需要使用/usr/local/nginx/sbin/nginx 如果不輸入路徑需要配置軟連線即

sudo ln -s /usr/local/nginx/sbin/nginx /usr/bin/nginx
複製程式碼

設定開機啟動

設定之前先來了解下update-rc.d命令, 該命令是用來自動的升級System V 型別初始化指令碼,就是你想要哪些東西在系統引導初始化時執行,那些東西是希望在關機或重啟時停止。
我們先要在/etc/init.d目錄下建立一個nginx的命令指令碼, 命令 sudo vi nginx 輸入以下內容

#!/bin/sh

### BEGIN INIT INFO
# Provides:      nginx
# Required-Start:    $local_fs $remote_fs $network $syslog $named
# Required-Stop:     $local_fs $remote_fs $network $syslog $named
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts the nginx web server
# Description:       starts nginx using start-stop-daemon
### END INIT INFO

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/nginx/sbin/nginx
NAME=nginx
DESC=nginx

# Include nginx defaults if available
if [ -r /etc/default/nginx ]; then
    . /etc/default/nginx
fi

STOP_SCHEDULE="${STOP_SCHEDULE:-QUIT/5/TERM/5/KILL/5}"

test -x $DAEMON || exit 0

. /lib/init/vars.sh
. /lib/lsb/init-functions

# Try to extract nginx pidfile
PID=$(cat /usr/local/nginx/conf/nginx.conf | grep -Ev '^\s*#' | awk 'BEGIN { RS="[;{}]" } { if ($1 == "pid") print $2 }' | head -n1)
if [ -z "$PID" ]; then
    PID=/run/nginx.pid
fi

if [ -n "$ULIMIT" ]; then
    # Set ulimit if it is set in /etc/default/nginx
    ulimit $ULIMIT
fi

start_nginx() {
    # Start the daemon/service
    #
    # Returns:
    #   0 if daemon has been started
    #   1 if daemon was already running
    #   2 if daemon could not be started
    start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON --test > /dev/null \
        || return 1
    start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON -- \
        $DAEMON_OPTS 2>/dev/null \
        || return 2
}

test_config() {
    # Test the nginx configuration
    $DAEMON -t $DAEMON_OPTS >/dev/null 2>&1
}

stop_nginx() {
    # Stops the daemon/service
    #
    # Return
    #   0 if daemon has been stopped
    #   1 if daemon was already stopped
    #   2 if daemon could not be stopped
    #   other if a failure occurred
    start-stop-daemon --stop --quiet --retry=$STOP_SCHEDULE --pidfile $PID --name $NAME
    RETVAL="$?"
    sleep 1
    return "$RETVAL"
}

reload_nginx() {
    # Function that sends a SIGHUP to the daemon/service
    start-stop-daemon --stop --signal HUP --quiet --pidfile $PID --name $NAME
    return 0
}

rotate_logs() {
    # Rotate log files
    start-stop-daemon --stop --signal USR1 --quiet --pidfile $PID --name $NAME
    return 0
}

upgrade_nginx() {
    # Online upgrade nginx executable
    # http://nginx.org/en/docs/control.html
    #
    # Return
    #   0 if nginx has been successfully upgraded
    #   1 if nginx is not running
    #   2 if the pid files were not created on time
    #   3 if the old master could not be killed
    if start-stop-daemon --stop --signal USR2 --quiet --pidfile $PID --name $NAME; then
        # Wait for both old and new master to write their pid file
        while [ ! -s "${PID}.oldbin" ] || [ ! -s "${PID}" ]; do
            cnt=`expr $cnt + 1`
            if [ $cnt -gt 10 ]; then
                return 2
            fi
            sleep 1
        done
        # Everything is ready, gracefully stop the old master
        if start-stop-daemon --stop --signal QUIT --quiet --pidfile "${PID}.oldbin" --name $NAME; then
            return 0
        else
            return 3
        fi
    else
        return 1
    fi
}

case "$1" in
    start)
        log_daemon_msg "Starting $DESC" "$NAME"
        start_nginx
        case "$?" in
            0|1) log_end_msg 0 ;;
            2)   log_end_msg 1 ;;
        esac
        ;;
    stop)
        log_daemon_msg "Stopping $DESC" "$NAME"
        stop_nginx
        case "$?" in
            0|1) log_end_msg 0 ;;
            2)   log_end_msg 1 ;;
        esac
        ;;
    restart)
        log_daemon_msg "Restarting $DESC" "$NAME"

        # Check configuration before stopping nginx
        if ! test_config; then
            log_end_msg 1 # Configuration error
            exit $?
        fi

        stop_nginx
        case "$?" in
            0|1)
                start_nginx
                case "$?" in
                    0) log_end_msg 0 ;;
                    1) log_end_msg 1 ;; # Old process is still running
                    *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
            *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
    reload|force-reload)
        log_daemon_msg "Reloading $DESC configuration" "$NAME"

        # Check configuration before stopping nginx
        #
        # This is not entirely correct since the on-disk nginx binary
        # may differ from the in-memory one, but that's not common.
        # We prefer to check the configuration and return an error
        # to the administrator.
        if ! test_config; then
            log_end_msg 1 # Configuration error
            exit $?
        fi

        reload_nginx
        log_end_msg $?
        ;;
    configtest|testconfig)
        log_daemon_msg "Testing $DESC configuration"
        test_config
        log_end_msg $?
        ;;
    status)
        status_of_proc -p $PID "$DAEMON" "$NAME" && exit 0 || exit $?
        ;;
    upgrade)
        log_daemon_msg "Upgrading binary" "$NAME"
        upgrade_nginx
        log_end_msg $?
        ;;
    rotate)
        log_daemon_msg "Re-opening $DESC log files" "$NAME"
        rotate_logs
        log_end_msg $?
        ;;
    *)
        echo "Usage: $NAME {start|stop|restart|reload|force-reload|status|configtest|rotate|upgrade}" >&2
        exit 3
        ;;
esac
複製程式碼

然後設定服務有執行許可權並註冊服務

#設定服務指令碼有執行許可權
sudo chmod +x /etc/init.d/nginx
#註冊服務
cd /etc/init.d/
sudo update-rc.d nginx defaults
複製程式碼

sudo ps -ef | grep nginx檢視nginx程式情況。
如果要取消開機啟動可以這樣 update-rc.d -f nginx remove
現在安裝基本完成,便可以使用如下nginx命令

sudo service nginx {start|stop|restart|reload|forcereload|status|configtest|rotate|upgrade}
複製程式碼

參考:
www.cnblogs.com/EasonJim/p/…
www.cnblogs.com/piscesLoveC…
www.cnblogs.com/wkun/p/3798…

新手上車,請多指教,如有問題,請聯絡本人:young5678@qq.com

相關文章